function  [p0, err, k, y] = newtontabla (r, f, df, p0, delta, epsilon, max1)

% Entrada - f es la funcion objetivo introducida como cadena de caracteres  'f'
%         - df es la derivada de  f  introducida como cadena de caracteres  'df'
%         - p0 es la aproximacion inicial a cero de  f
%	      - delta es la tolerancia para  p0
%	      - epsilon es la tolerancia para los valores de la funcion  y
%	      - max1 es el numero maximo de iteraciones
% Salida  - p0 es la aproximacion de Newton-Raphson hacia cero
%	      - err es el error estimado para  p0
%	      - k es el numero de iteraciones
%	      - y es el valor de la funcion  f(p0)

%  METODOS NUMERICOS: Programas en Matlab
% (c) 2004 por John H. Mathews y Kurtis D. Fink
%  Software complementario acompa�ando al texto:
%  METODOS NUMERICOS con Matlab, Cuarta Edicion
%  ISBN: 0-13-065248-2
%  Prentice-Hall Pub. Inc.
%  One Lake Street
%  Upper Saddle River, NJ 07458

%%%%%%%%%%PPPPPPPPPPPP%%%%%%%%%%%%
% Las lineas rodeadas por %%%%%PPPPP%%%%%%%%
% se agregan para ofrecer resultados en forma de tabla
% SE DEBE CONOCER LA RAIZ Y ALMACENARLA EN LA VARIABLE r
%
%raices=double(solve('x^4+2*x^3-7*x^2+3'))
%r = abs(double(solve('1/x-tan(x)')));
disp(' METODO DE NEWTON ');
disp(' FRACCION 1 = abs(p-p_k)/(abs(p-p_k-1)) ');
disp(' FRACCION 2 = abs(p-p_k)/(abs(p-p_k-1))^2 ');

disp('   k      p_k    f(p_k)   FRACCION 1 FRACCION 2 ');
rnew=abs(r-p0);
out=[0,p0,f(p0)];
fprintf('%4.0f %8.3e %8.3e\n',out);

%%%%%%%%%%%PPPPPPPPPP%%%%%%%%%%%%%%%%%%
for  k = 1:max1	
    p1 = p0 - feval(f, p0) / feval(df, p0);
%%%%%%%%%%%%%%PPPPPPPPPPPPPPP%%%%%%%
   rold=rnew;
   rnew=abs(r-p1);
    out=[k,p1,f(p1),rnew/rold,rnew/rold^2];
 	fprintf('%4.0f %8.3e %8.3e %8.3e %8.3e\n',out);
%%%%%%%%%%%%%%%PPPPPPPPPPP%%%%%%%%%

    err = abs(p1 - p0);
	relerr = 2 * err / (abs(p1) + delta);
	p0 = p1;
	y = feval(f, p0);
	if  (err < delta)  |  (relerr < delta)  |  (abs(y) < epsilon), break, end
end
